package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.HeartBeat;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import java.util.List;

/**
 * 小车心跳数据(HeartBeat)表数据库访问层
 *
 * @author makejava
 * @since 2024-04-19 15:26:15
 */
public interface HeartBeatMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param heartId 主键
     * @return 实例对象
     */
    HeartBeat queryById(Long heartId);


    /**
     * 通过ID查询单条数据
     *
     * @param siteId 主键
     * @return 实例对象
     */
    HeartBeat queryBysiteId(Long siteId);


    /**
     * 通过ID查询单条数据
     *
     * @param siteId 主键
     * @return 实例对象
     */
    List<HeartBeat> queryBysiteIdTime(@Param( "siteId")Long siteId, @Param( "startTime") String startTime, @Param( "endTime") String endTime);

    /**
     * 查询指定行数据
     *
     * @param heartBeat 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<HeartBeat> queryAllByLimit(HeartBeat heartBeat, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param heartBeat 查询条件
     * @return 总行数
     */
    long count(HeartBeat heartBeat);

    /**
     * 新增数据
     *
     * @param heartBeat 实例对象
     * @return 影响行数
     */
    int insert(HeartBeat heartBeat);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<HeartBeat> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<HeartBeat> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<HeartBeat> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<HeartBeat> entities);

    /**
     * 修改数据
     *
     * @param heartBeat 实例对象
     * @return 影响行数
     */
    int update(HeartBeat heartBeat);

    /**
     * 通过主键删除数据
     *
     * @param heartId 主键
     * @return 影响行数
     */
    int deleteById(Long heartId);

}

